diff a/test/micro/org/openjdk/bench/valhalla/types/R32byte.java b/test/micro/org/openjdk/bench/valhalla/types/R32byte.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/types/R32byte.java
@@ -0,0 +1,85 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.types;
+
+public class R32byte implements Int32, ByByte {
+
+    public final byte v0;
+    public final byte v1;
+    public final byte v2;
+    public final byte v3;
+
+    public R32byte(int v) {
+        this((byte) (v >>> 24), (byte) (v >>> 16), (byte) (v >>> 8), (byte) (v));
+    }
+
+    public R32byte(byte v0, byte v1, byte v2, byte v3) {
+        this.v0 = v0;
+        this.v1 = v1;
+        this.v2 = v2;
+        this.v3 = v3;
+    }
+
+    private static final int MASK = 0xFF;
+
+    @Override
+    public long longValue() {
+        return (long) intValue();
+    }
+
+    @Override
+    public int intValue() {
+        return (((v0 & MASK) << 24) | ((v1 & MASK) << 16) | ((v2 & MASK) << 8) | (v3 & MASK));
+    }
+
+    @Override
+    public Int32 neg() {
+        return new R32byte(-intValue());
+    }
+
+    @Override
+    public Int32 add(Int32 o) {
+        return new R32byte(intValue() + o.intValue());
+    }
+
+    @Override
+    public Int32 sub(Int32 o) {
+        return new R32byte(intValue() - o.intValue());
+    }
+
+    @Override
+    public Int32 mult(Int32 o) {
+        return new R32byte(intValue() * o.intValue());
+    }
+
+    @Override
+    public int compareTo(Int32 o) {
+        return Integer.compare(intValue(), o.intValue());
+    }
+
+    @Override
+    public byte byteSum() {
+        return (byte) (v0 + v1 + v2 + v3);
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/types/R32int.java b/test/micro/org/openjdk/bench/valhalla/types/R32int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/types/R32int.java
@@ -0,0 +1,92 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.types;
+
+public class R32int implements Int32, ByInt {
+
+    public final int v0;
+
+    public R32int() {
+        this.v0 = 0;
+    }
+
+    public R32int(int val) {
+        this.v0 = val;
+    }
+
+    @Override
+    public long longValue() {
+        return v0;
+    }
+
+    @Override
+    public int intValue() {
+        return v0;
+    }
+
+    @Override
+    public Int32 neg() {
+        return new R32int(-v0);
+    }
+
+    @Override
+    public Int32 add(Int32 o) {
+        return new R32int(v0 + o.intValue());
+    }
+
+    public Int32 add(R32int o) {
+        return new R32int(v0 + o.v0);
+    }
+
+    @Override
+    public Int32 sub(Int32 o) {
+        return new R32int(v0 - o.intValue());
+    }
+
+    public Int32 sub(R32int o) {
+        return new R32int(v0 - o.v0);
+    }
+
+    @Override
+    public Int32 mult(Int32 o) {
+        return new R32int(v0 * o.intValue());
+    }
+
+    public Int32 mult(R32int o) {
+        return new R32int(v0 * o.v0);
+    }
+
+    @Override
+    public int compareTo(Int32 o) {
+        return Integer.compare(v0, o.intValue());
+    }
+
+    public int compareTo(R32int o) {
+        return Integer.compare(v0, o.v0);
+    }
+
+    @Override
+    public int intSum() {
+        return v0;
+    }
+}
diff a/test/micro/org/openjdk/bench/valhalla/types/R64byte.java b/test/micro/org/openjdk/bench/valhalla/types/R64byte.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/types/R64byte.java
@@ -0,0 +1,68 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.types;
+
+public class R64byte implements Int64, ByByte {
+
+    public final byte v0;
+    public final byte v1;
+    public final byte v2;
+    public final byte v3;
+    public final byte v4;
+    public final byte v5;
+    public final byte v6;
+    public final byte v7;
+
+    public R64byte(long v) {
+        this((byte) (v >>> 56), (byte) (v >>> 48), (byte) (v >>> 40), (byte) (v >>> 32), (byte) (v >>> 24), (byte) (v >>> 16), (byte) (v >>> 8), (byte) (v));
+    }
+
+    public R64byte(byte v0, byte v1, byte v2, byte v3, byte v4, byte v5, byte v6, byte v7) {
+        this.v0 = v0;
+        this.v1 = v1;
+        this.v2 = v2;
+        this.v3 = v3;
+        this.v4 = v4;
+        this.v5 = v5;
+        this.v6 = v6;
+        this.v7 = v7;
+    }
+
+    private static final long MASK = 0xFFL;
+    private static final int IMASK = 0xFF;
+
+    @Override
+    public long longValue() {
+        return ((v0 & MASK) << 56) | ((v1 & MASK) << 48) | ((v2 & MASK) << 40) | ((v3 & MASK) << 32) | ((v4 & MASK) << 24) | ((v5 & MASK) << 16) | ((v6 & MASK) << 8) | (v7 & MASK);
+    }
+
+    @Override
+    public int intValue() {
+        return ((v4 & IMASK) << 24) | ((v5 & IMASK) << 16) | ((v6 & IMASK) << 8) | (v7 & IMASK);
+    }
+
+    @Override
+    public byte byteSum() {
+        return (byte) (v0 + v1 + v2 + v3 + v4 + v5 + v6 + v7);
+    }
+}
diff a/test/micro/org/openjdk/bench/valhalla/types/R64int.java b/test/micro/org/openjdk/bench/valhalla/types/R64int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/types/R64int.java
@@ -0,0 +1,55 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.types;
+
+public class R64int implements Int64, ByInt {
+
+    public final int v0;
+    public final int v1;
+
+    public R64int(long v) {
+        this((int) (v >>> 32), (int) v);
+    }
+
+    public R64int(int hi, int lo) {
+        this.v0 = hi;
+        this.v1 = lo;
+    }
+
+    private static final long MASK = 0xFFFFFFFFL;
+
+    @Override
+    public long longValue() {
+        return (v0 & MASK) << 32 | (v1 & MASK);
+    }
+
+    @Override
+    public int intValue() {
+        return v1;
+    }
+
+    @Override
+    public int intSum() {
+        return v0 + v1 ;
+    }
+}
diff a/test/micro/org/openjdk/bench/valhalla/types/R64long.java b/test/micro/org/openjdk/bench/valhalla/types/R64long.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/types/R64long.java
@@ -0,0 +1,47 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.types;
+
+public class R64long extends A64long  {
+
+    public final long v0;
+
+    public R64long(long v0) {
+        this.v0 = v0;
+    }
+
+    @Override
+    public long longValue() {
+        return v0;
+    }
+
+    @Override
+    public int intValue() {
+        return (int) v0;
+    }
+
+    @Override
+    public long longSum() {
+        return v0;
+    }
+}
diff a/test/micro/org/openjdk/bench/valhalla/types/RComplex.java b/test/micro/org/openjdk/bench/valhalla/types/RComplex.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/types/RComplex.java
@@ -0,0 +1,62 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.types;
+
+public class RComplex implements Complex {
+
+    public final double re;
+    public final double im;
+
+    public RComplex(double re, double im) {
+        this.re =  re;
+        this.im =  im;
+    }
+
+    @Override
+    public double re() { return re; }
+
+    @Override
+    public double im() { return im; }
+
+    @Override
+    public RComplex add(Complex that) {
+        return new RComplex(this.re + that.re(), this.im + that.im());
+    }
+
+    public RComplex add(RComplex that) {
+        return new RComplex(this.re + that.re, this.im + that.im);
+    }
+
+    @Override
+    public RComplex mul(Complex that) {
+        return new RComplex(this.re * that.re() - this.im * that.im(),
+                           this.re * that.im() + this.im * that.re());
+    }
+
+    public RComplex mul(RComplex that) {
+        return new RComplex(this.re * that.re - this.im * that.im,
+                           this.re * that.im + this.im * that.re);
+    }
+
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/types/ROpt.java b/test/micro/org/openjdk/bench/valhalla/types/ROpt.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/types/ROpt.java
@@ -0,0 +1,61 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.types;
+
+import java.util.NoSuchElementException;
+
+public class ROpt<T> implements Opt<T> {
+
+    public T value;
+
+    private <T> ROpt() {
+        this.value = null;
+    }
+
+    private ROpt(T value) {
+        this.value = value;
+    }
+
+    public static <T> ROpt<T> of() {
+        return new ROpt<>(null);
+    }
+
+    public static <T> ROpt<T> of(T value) {
+        return new ROpt<>(value);
+    }
+
+    public T get() {
+        if (value == null) {
+            throw new NoSuchElementException("No value present");
+        }
+        return value;
+    }
+
+    public boolean isPresent() {
+        return value != null;
+    }
+
+    public boolean isEmpty() {
+        return value == null;
+    }
+}
diff a/test/micro/org/openjdk/bench/valhalla/util/SizeBase.java b/test/micro/org/openjdk/bench/valhalla/util/SizeBase.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/util/SizeBase.java
@@ -0,0 +1,54 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.util;
+
+import org.openjdk.jmh.annotations.BenchmarkMode;
+import org.openjdk.jmh.annotations.Fork;
+import org.openjdk.jmh.annotations.Measurement;
+import org.openjdk.jmh.annotations.Mode;
+import org.openjdk.jmh.annotations.OutputTimeUnit;
+import org.openjdk.jmh.annotations.Param;
+import org.openjdk.jmh.annotations.Scope;
+import org.openjdk.jmh.annotations.State;
+import org.openjdk.jmh.annotations.Warmup;
+
+import java.util.concurrent.TimeUnit;
+
+@Fork(3)
+@Warmup(iterations = 5, time = 1)
+@Measurement(iterations = 5, time = 1)
+@OutputTimeUnit(TimeUnit.NANOSECONDS)
+@BenchmarkMode(Mode.AverageTime)
+public class SizeBase {
+
+    @State(Scope.Thread)
+    public static abstract class SizeState {
+
+        @Param({
+                "100",      // tiny size, to fit into all caches and check codegeneration quality
+                "1000000"   // large size, to be out of all caches and memory effects
+        })
+        public int size;
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/util/Utils.java b/test/micro/org/openjdk/bench/valhalla/util/Utils.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/util/Utils.java
@@ -0,0 +1,53 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.util;
+
+import java.util.Random;
+
+public class Utils {
+
+    public static void shuffle(int[] a, Random rnd) {
+        for (int i = a.length; i > 1; i--) {
+            int idx = rnd.nextInt(i);
+            int tmp = a[i - 1];
+            a[i - 1] = a[idx];
+            a[idx] = tmp;
+        }
+
+    }
+
+    public static int[] makeRandomRing(int size) {
+        int[] A = new int[size - 1];
+        for (int i = 0; i < A.length; i++) {
+            A[i] = i + 1;
+        }
+        shuffle(A, new Random(42));
+        int[] a = new int[size];
+        int x = 0;
+        for (int i = 0; i < A.length; i++) {
+            x = a[x] = A[i];
+        }
+        a[x] = 0;
+        return a;
+    }
+}
